"use strict";
/** Initialize an empty document with root element */
function renderTestingPlatform() {
    // Let's mount components under a new div with this id
    var rootId = 'cypress-root';
    var document = cy.state('document');
    if (document.getElementById(rootId)) {
        return;
    }
    var rootNode = document.createElement('div');
    rootNode.setAttribute('id', rootId);
    document.getElementsByTagName('body')[0].prepend(rootNode);
    var selector = '#' + rootId;
    return cy.get(selector, { log: false });
}
before(function () {
    renderTestingPlatform();
});
/**
 * Remove any style or extra link elements from the iframe placeholder
 * left from any previous test
 *
 */
function cleanupStyles() {
    var document = cy.state('document');
    var styles = document.body.querySelectorAll('style');
    styles.forEach(function (styleElement) {
        document.body.removeChild(styleElement);
    });
    var links = document.body.querySelectorAll('link[rel=stylesheet]');
    links.forEach(function (link) {
        document.body.removeChild(link);
    });
}
beforeEach(cleanupStyles);
